
import serial


# Class to manage and drive Blinkenlichten nodes over a silly serial protocol. Note, lots of stuff not implemented or tested yet; use at your own risk.
# 3-byte serial protocol to Arduino 'talker' script: send 0x55 (sync byte) followed by the Blinkenlichten address and cmd bytes.

class Blinken:
#  float mx, my;
#  int size = unit;
#  float x, y = 0;
#  int xdir = 1;
#  int ydir = 1;
#  float speed;
    port = None

    @staticmethod
    def _set_port(port):
        Blinken.port = port

    @staticmethod
    def _send_raw(addr, cmd):

        Blinken.port.write(serial.to_bytes([0x55, addr & 0xFF, cmd & 0xFF]))
        #ret = Blinken.port.read(1)


    @staticmethod
    def _init():
        Blinken._send_raw(0, 0x70);  # all off

    @staticmethod
    def _set_group(addr, group_addr):
        if(group_addr > 0x3F):
            print "Warning: Group address" + group_addr + " out of range (0x00, 0x3F)"
        Blinken._send_raw(addr, 0xC0 | group_addr)  # 0b11xxxxxx


    @staticmethod
    def _set_color(addr, r, g, b):
        # FIXME: Bus command optimizations. For now just write every color individually...
        Blinken._send_raw(addr, 0x40 | (r & 0x0F))
        Blinken._send_raw(addr, 0x20 | (g & 0x0F))
        Blinken._send_raw(addr, 0x10 | (b & 0x0F))


  # Set color using standard Processing color space (RGB 0 ~ 255) and normalize to Blinken colorspace (0 ~ 8)
    @staticmethod
    def _set_color_norm(addr, r, g, b):
        pass
    #FIXME: Writeme
    #blinken_set_color(addr, int(map(r, 0, 255, 0, 8)), int(map(g, 0, 255, 0, 8)), int(map(b, 0, 255, 0, 8)) );


    @staticmethod
    def _check_addr(addr):
        pass
      # FIXME: Writeme
#   {
#     Blinken.port.clear();  // flush any pending buffer bytes
#     blinken_send_raw(addr, 0x84);  // IDentify
#
#     println("waiting for response from " + addr);
#     while (myPort.available() == 0) {}  // wait for byte
#     int rcv=myPort.read();
#     if (rcv == 255)
#     {
#       println("Device " + addr + " responded!");
#       delay(3);
#       return(true);
#     }
#     else
#     {
#        delay(3);
#        return(false);
#     }
#   }

    @staticmethod
    def _get_addr_list():
        pass
      #FIXME: Writeme
#   {
#     ArrayList addr_list = new ArrayList();
#     for (int i=1; i<256; i++)
#     {
#         if (blinken_check_addr(i) == true)
#         {
#           addr_list.add(new Integer(i));
#         }
#     }
#     return addr_list;
#   }

    def __init__(self, addr):
        # Basics: node ID and group ID (if any)
        self.addr = addr
        self.group_id = 0

        # Control if updates are applied immediately. Default is True
        self.immediate = True

        # Cartesian position data; currently unused (could be useful for mapping nodes e.g. to positions within onscreen raster effects)
        self.x = 0
        self.y = 0
        self.z = 0

        # Variables holding this node's actual (written out) color
        self.r = 0
        self.g = 0
        self.b = 0

        # Variables holding this node's pending color. A call to update() will physically transfer the 'pending' color to the node (send the serial data, copy newr/g/b/ r/g/b), clear the updated flag)
        self.newr = 0
        self.newg = 0
        self.newb = 0

        self.updated = False


    def send_raw(self, cmd):
        _send_raw(self.addr, cmd)

    def set_group(self, group_addr):
        self._set_group(self.addr, group_addr)

    def set_color(self, r, g, b):
        self.newr = r
        self.newg = g
        self.newb = b
        self.updated = True
        if(self.immediate):
            self.update()

    def set_color_norm(self, r, g, b):
        # FIXME: Use update mechanism
        _set_color_norm(self.addr, r, g, b)

    def check_addr(self):
        _check_addr(self.addr)

  # Apply the actual color update
    def update(self):
        self.r = self.newr
        self.g = self.newg
        self.b = self.newb
        self._set_color(self.addr, self.r, self.g, self.b)
        self.updated = False




# ----------------------------------



