// Extremely simple sketch to drive a bus of Blinkenlichten LED nodes using serial data from a PC.
// Each command from the PC should consist of 3 bytes (0x55 sync byte followed by the Blinken address and command bytes).
// The corresponding Blinken one-wire bitstream will be sent out on the pin chosen below.


#include <Blinken.h> // Blinkenlichten protocol library, download at http://tim.cexx.org/?p=453

byte addr;
byte data;

// Change to the pin #s the Blinken bus is attached to. If any are unused (e.g. power/ground), just pick any unused pins (laziness).
int dataPin=12;
int powerPin=5;
int groundPin=7;
int ledPin = 13;

Blinken blinken(powerPin, dataPin, groundPin);

void setup()
{
  blinken.reset(); // Make sure if the Adruino was powered but not active (e.g. during code upload) and pins may have been floating, everyone is back in sync.
  blinken.clear_all_groups();
  pinMode(ledPin, OUTPUT);
  digitalWrite(ledPin, LOW);
  Serial.begin(115200);
}



void loop()
{
  while(Serial.read() != 0x55){;}
  while(Serial.available() < 2) {;}
  addr = Serial.read();
  data = Serial.read();
  digitalWrite(ledPin, HIGH);
  blinken.writeraw(addr, data); 
  Serial.write('a');
  digitalWrite(ledPin, LOW);
  //Serial.println(Serial.available());
}
